# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import datetime as dt
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class User(UniversalBaseModel):
    """
    Representation of a user.

    Parameters:
    id (str): The unique identifier of the user.
    name (str): The name of the user.
    created_at (datetime): The creation date of the user.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The human-friendly ID of the User
    """

    organization_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The organization id of the user
    """

    name: str = pydantic.Field()
    """
    The name of the user.
    """

    created_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    The creation date of the user.
    """

    updated_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    The update date of the user.
    """

    is_deleted: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Whether this user is deleted or not.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
